books/urls.py
from django.urls import path, include

from . import views

app_name = "books"

urlpatterns = [
    path('books/', views.BookListView.as_view(), name="book_list"),
    path('books/<uuid:pk>/', views.BookDetailView.as_view(), name="book_detail"),

]

bookstore_project/urls.py
"""
    Root URLconf
"""


from django.contrib import admin
from django.urls import path, include

from django.conf import settings                # importing settings
from django.conf.urls.static import static      # for media files

urlpatterns = [
    # Django admin
    path('admin/', admin.site.urls),

    # User Management
    # path('accounts/', include("django.contrib.auth.urls")),           
    # path('accounts/', include("users.urls", namespace="users")),
    path('accounts/', include("allauth.urls")),                     # Using django-allauth urls for login, signup...


    # Local Apps
    path('', include("pages.urls", namespace="pages")),
    path('', include("books.urls", namespace="books")),
    path('orders/', include("orders.urls", namespace="orders")),


]

urlpatterns += static(settings.MEDIA_URL, document_root = settings.MEDIA_ROOT)

orders/urls.py
from django.urls import path, include

from . import views

app_name = "orders"

urlpatterns = [
    path('', views.OrdersPageView.as_view(), name="orders"),
    path('charge/', views.charge, name="charge"),

]

pages/urls.py
from django.urls import path, include

from . import views

app_name = "pages"
urlpatterns = [
    path('', views.HomepageView.as_view(), name="home"),
]

users/urls.py
from django.urls import path, include

from . import views

app_name = "users"
urlpatterns = [
    path('signup/', views.SignupView.as_view(), name="signup"),
]

books/models.py
import uuid

from django.db import models
from django.urls import reverse
from django.contrib.auth import get_user_model

# Create your models here.
class Book(models.Model):
    id          = models.UUIDField(
        primary_key=True,
        default=uuid.uuid4,
        editable=False
    )
    title       = models.CharField(max_length=100)
    author      = models.CharField(max_length=100)
    price       = models.DecimalField(max_digits=6, decimal_places=2)
    cover       = models.ImageField(upload_to="books/covers/", blank=True)

    class Meta:
        permissions = [
            ('special_status', 'Can read all books'),
        ]

    def __str__(self):
        return self.title
    
    def get_absolute_url(self):
        return reverse("books:book_detail", kwargs={"pk": self.pk})       # args=[str(self.id)]
    

class Review(models.Model):
    book            = models.ForeignKey(Book,related_name="reviews", on_delete=models.CASCADE)
    review          = models.CharField(max_length=255)
    author          = models.ForeignKey(get_user_model(), on_delete=models.CASCADE)

    def __str__(self):
        return self.review
    

contacts/models.py
from django.db import models

# Create your models here.

orders/models.py
from django.db import models

# Create your models here.

pages/models.py
from django.db import models

# Create your models here.

users/models.py
from django.db import models
from django.contrib.auth.models import AbstractUser

# Create your models here.
class CustomUser(AbstractUser):
    pass

users/forms.py
from django.contrib.auth import get_user_model
from django import forms
from django.contrib.auth.forms import UserCreationForm, UserChangeForm


class CustomUserCreationForm(UserCreationForm):
    class Meta:
        model = get_user_model()
        fields = ('email','username')

class CustomUserChangeForm(UserChangeForm):
    class Meta:
        model = get_user_model()
        fields = ('email','username')

books/views.py
from django.shortcuts import render
from django.views.generic import ListView, DetailView
from django.contrib.auth.mixins import LoginRequiredMixin, PermissionRequiredMixin


from . import models
# Create your views here.
class BookListView(LoginRequiredMixin, ListView):
    model = models.Book
    
    template_name = 'books/book_list.html'
    context_object_name = "books"
    login_url = "account_login"

class BookDetailView(LoginRequiredMixin, PermissionRequiredMixin, DetailView):
    model = models.Book
    template_name = 'books/book_details.html'
    context_object_name = "book"
    login_url = "account_login"
    permission_required = ('books.special_status',)
    # permission_required = ()

contacts/views.py
from django.shortcuts import render

# Create your views here.

orders/views.py
import stripe

from django.shortcuts import render
from django.views.generic import TemplateView
from django.conf import settings
from django.contrib.auth.models import Permission

from bookstore_project.loggingConfig import logging
logger = logging.getLogger(__name__)
# Create your views here.
class OrdersPageView(TemplateView):
    template_name = "orders/purchase.html"

    def get_context_data(self, **kwargs):
        context = super().get_context_data(**kwargs)
        context['stripe_key'] = settings.STRIPE_TEST_PUBLISHABLE_KEY
        logger.debug(f'Stripe Publishable Key is: {context.get("stripe_key")}')
        return context

stripe.api_key = settings.STRIPE_TEST_SECRET_KEY
def charge(request):
    # permission = Permission.objects.get(codename="special_status")
    # user = request.user
    # user.user_permissions.add(permission)
    if request.method == "POST":
        # breakpoint()
        logger.info(f"stripeToken is : {request.POST.get('stripeToken', None)}")
        charge = stripe.Charge.create(
            amount=4055,
            currency='usd',
            description='Purchase All Books',
            source=request.POST['stripeToken']
        )
        # breakpoint()
        return render(request, "orders/charge.html")

pages/views.py
from django.shortcuts import render
from django.views.generic import TemplateView

from bookstore_project.loggingConfig import logging
logger = logging.getLogger(__name__)

# Create your views here.
class HomepageView(TemplateView):
    template_name = "pages/home.html"
    def dispatch(self, request, *args, **kwargs):
        logger.debug("Home page is being called.")
        return super().dispatch(request, *args, **kwargs)

users/views.py
from django.shortcuts import render
from django.views import generic
from django.urls import reverse_lazy

from . import forms

# Create your views here.

class SignupView(generic.CreateView):
    form_class = forms.UserCreationForm
    template_name = "users/signup.html"
    success_url = reverse_lazy("pages:home")
    

templates/base/_base.html
{% load static %} 
<!doctype html>
<html lang="en">
  <head>
    <!-- Required meta tags -->
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">

    <!-- Bootstrap CSS -->
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/css/bootstrap.min.css" integrity="sha384-Vkoo8x4CGsO3+Hhxv8T/Q5PaXtkKtu6ug5TOeNV6gBiFeWPGFN9MuhOf23Q9Ifjh" crossorigin="anonymous">
    <link rel="stylesheet" href="{% static 'css/base.css' %}">
    <title>{% block title %}
    {% endblock title %}</title>
    {% block head %}
    {% endblock head %}
  </head>
  <body>
    <div class="container">
    
      {% block content %}
      {% endblock content %}
      
    </div>

    <!-- Optional JavaScript -->
    <!-- jQuery first, then Popper.js, then Bootstrap JS -->
    <script src="https://code.jquery.com/jquery-3.4.1.slim.min.js" integrity="sha384-J6qa4849blE2+poT4WnyKhv5vZF5SrPo0iEjwBvKU7imGFAV0wwj1yYfoRSJoZ+n" crossorigin="anonymous"></script>
    <script src="https://cdn.jsdelivr.net/npm/popper.js@1.16.0/dist/umd/popper.min.js" integrity="sha384-Q6E9RHvbIyZFJoft+2mJbHaEWldlvI9IOYy5n3zV9zzTtmI3UksdQRVvoxMfooAo" crossorigin="anonymous"></script>
    <script src="https://stackpath.bootstrapcdn.com/bootstrap/4.4.1/js/bootstrap.min.js" integrity="sha384-wfSDF2E50Y2D1uUdj0O3uMBJnjuUD4Ih7YwaYd1iqfktj0Uod8GCExl3Og8ifwB6" crossorigin="anonymous"></script>
    {% block javascript %}
      <script src="{% static 'js/base.js' %}"></script>
    {% endblock javascript %}
  </body>
</html>

templates/books/book_details.html
{% extends 'base/_base.html' %}

{% block title %}{{book.title}}
{% endblock title %}

{% block content %}


    <div>
        {% if book.cover %}
            <img src="{{ book.cover.url }}" alt="{{ book.title }}">
        {% endif %}
        <h3>{{book.title}}</h3>
        <h5>{{book.author}}</h5>
        <h5>{{book.price}}</h5>
        <div>
            <h4>Reviews</h4>
            <ul>
            {% for review in book.reviews.all %}
                <li>({{review.author}}) : {{review.review}}</li>    
            {% endfor %}
            </ul>
        </div>
        
    </div>
    

{% endblock content %}

templates/books/book_list.html
{% extends 'base/_base.html' %}

{% block title %}All Books
{% endblock title %}

{% block content %}

{% if not perms.books.special_status %}
    <a href="{% url 'orders:orders' %}" class="btn btn-success">Purchase All Books</a>
{% endif %}

<br>
{% for book in books %}
    <div>
        {% comment %} <h3><a href="{% url 'books:book_detail' book.id %}">{{book.title}}</a></h3> {% endcomment %}
        <h3><a href="{{ book.get_absolute_url }}">{{book.title}}</a></h3>

    </div>
{% endfor %}

{% endblock content %}

templates/orders/charge.html
{% extends 'base/_base.html' %}

{% block title %}Charge
{% endblock title %}

{% block content %}
<h2>Thank you for your order ! You have now access to <a href="{% url 'books:book_list' %}">All Books</a>.</h2>

{% endblock content %}

templates/orders/purchase.html
{% extends 'base/_base.html' %}

{% block title %}Orders
{% endblock title %}

{% block content %}
<h1>Orders Page</h1>
<p>Buy for $40.55</p>
<form action="{% url 'orders:charge' %}" method="post">
{% csrf_token %}
<script src="https://checkout.stripe.com/checkout.js" class="stripe-button" data-key="{{stripe_key}}"
    data-description="All Books" data-amount="4055" data-locale="auto">
    </script>
</form>
{% endblock content %}

templates/pages/home.html
{% extends 'base/_base.html' %}
{% load static %}
{% block title %}Home | Landing Page
{% endblock title %}

{% block content %}

<h2>Home Page</h2>
<img class="bookcover" src="{% static 'images/djangoforprofessionals.jpg' %}" height="300" alt="django for professionals cover image" >
{% if request.user.is_authenticated %}
<p>Hi {{request.user.email}}</p>
{% comment %} <p><a href="{% url 'logout' %}">Logout</a></p> {% endcomment %}    <!-- django auth url names -->
<p><a href="{% url 'account_logout' %}">Logout</a></p>   <!-- django-allauth url names --> 


{% else %}
<p>You are not logged in !</p>
{% comment %} <a href="{% url 'login' %}">Log In</a> {% endcomment %}
{% comment %} <a href="{% url 'users:signup' %}">Sign Up</a> {% endcomment %}
<a href="{% url 'account_login' %}">Log In</a>
<a href="{% url 'account_signup' %}">Sign Up</a>

{% endif %}


{% endblock content %}

templates/users/signup.html
{% extends 'base/_base.html' %}
{% load crispy_forms_tags %}

{% block title %}Signup | Registration
{% endblock title %}

{% block content %}

<h2>Sign Up</h2>
<form method="post">
    {% csrf_token %}
    <table>
        {{form|crispy}}
    </table>
        <button type="submit" class="btn btn-success">Register</button>
</form>

{% endblock content %}